package media;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;

import media.data.Rating;

/**
 *
 * @author Attila Bertók (BEALAGT.ELTE)
 */
public class Media implements IMediaManager {
    private ArrayList<Rating> mList = new ArrayList<Rating>();


    public int getRatingsNumber() {
        return this.mList.size();
    } // public int getRatingsNumber()

    public Collection<Rating> getRatings() {
        return java.util.Collections.unmodifiableCollection(this.mList);
    } // public Collection<Rating> getRatings()

    public void addRating(final Rating rating) {
        this.mList.add(rating);
    } // public void addRating()

    public void modifyRating(final long id, final int score) {
        Rating tmp = new Rating(id, null, 0);
        int index = this.mList.indexOf(tmp);
        this.mList.get(index).setScore(score);
//        for (Rating r : this.mList) {
//            if (r.equals(tmp)) {
//                r.setScore(score);
//            }
//        }
    } // public void modifyRating()

    public void deleteRating(final long id) {
        Rating tmp = new Rating(id, null, 0);

        for (Iterator<Rating> i = this.mList.iterator(); i.hasNext(); ) {
            if (i.next().equals(tmp)) {
                i.remove();
            } // check whether the item was found
        } // for loop
    } // public void deleteRating()

    public Rating getWorstRating() {
        ArrayList<Rating> templist = new ArrayList<Rating>();
        templist.addAll(this.mList);
        Collections.sort(templist);
        return templist.get(0);
    } // public Rating getWorstRating()

    public Rating getBestRating() {
        ArrayList<Rating> templist = new ArrayList<Rating>();
        templist.addAll(this.mList);
        Collections.sort(templist);
        return templist.get(templist.size() - 1);
    } // public Rating getBestRating()

    public Collection<Rating> sort(final Collection<Rating> input) {
        return input;
    } // public Collection<Rating> sort()
} // public class Media
