package media.data;

/**
 *
 * @author Attila Bertók (BEALAGT.ELTE)
 */
public class Rating implements Comparable<Rating> {
    // private properties
    private long id;
    private AMedia media;
    private Integer score;

    // constructor
    public Rating(final long id, final AMedia media, final int score) {
        this.id = id;
        this.media = media;
        this.score = score;
    } // public Rating constructor

    // public accessors
    public long getId() {
        return this.id;
    } // public long getId()

    public long setId(final int id) {
        this.id = id;
        return this.id;
    } // public long setId(final int id)

    public AMedia getMedia() {
        return this.media;
    } // public AMedia getMedia()

    public AMedia setMedia(final AMedia media) {
        this.media = media;
        return this.media;
    } // public AMedia setMedia()

    public Integer getScore() {
        return this.score;
    } // public Integer getScore()

    public Integer setScore(final int score) throws InvalidScoreException {
        if (score > 0 && score <= 5) {
            this.score = score;
            return this.score;
        } else {
            throw new InvalidScoreException("Invalid score!");
        } // score within bounds
    } // public Integer setScore()

    // toString method
    @Override
    public String toString() {
        if (this.media != null && this.score != null) {
            String retVal = "@Rating: ";
            retVal += "ID: " + this.id + "; media: " + this.media.toString();
            retVal += "; score: " + this.score.toString();
            return retVal;
        } else {
            throw new InvalidStateException("Rating not initialized");
        } // score is null
    } // public String toString()

    // hashCode method
    @Override
    public int hashCode() {
        int hash = 3;
        hash = 73 * hash + (int) (this.id ^ (this.id >>> 32));
        return hash;
    } // public int hashCode()

    // equals method
    @Override
    public boolean equals(final Object obj) {
        if (obj instanceof Rating) {
            Rating objRating = (Rating) obj;
            if (this.id == objRating.getId()) {
                return true;
            } else {
                return false;
            } // check whether the objectIDs are equal
        } else {
            return false;
        } // check whether the object is a Rating
    } // public boolean equals()

    // compareTo method
    public int compareTo(Rating obj) {
        return this.score - obj.getScore();
    } // public int compareTo()

} // public class Rating
